:i ( [char] ) parse drop ;
:i \ 10 parse drop ;

\ Core Definitions

:i " 
    [char] " parse 
    compiling if postpone literal then ;

:i ." 
    [char] " parse 
    compiling if 
        postpone literal
        ['] . compile,
    else
        . 
    then ;

: over ( a b -- a b a )
  swap ( b a )
  dup ( b a a )
  rot ( a a b )
  swap ( a b a ) ;

: 2dup ( a b -- a b a b ) over over ;

: 2drop ( a b -- )
  drop drop ;

: 1+ ( n -- n+1 ) 1 + ;

: = - if 0 else -1 then ;

: , ( o -- )
  here !
  here 1+ here! ;

: rdrop ( r:o -- ) r> drop ;

: variable create 1 allot ;

: constant create , does> @ ;

:i do 
  postpone >r 
  postpone >r 
  postpone begin ;

:i loop
  postpone r> 
  postpone r> 
  ['] 1+ compile,
  ['] 2dup compile,
  ['] = compile,
  postpone if
  ['] 2drop compile,
  postpone leave
  postpone then
  postpone >r 
  postpone >r 
  postpone repeat ;

:i i
  postpone r>
  postpone r>
  ['] dup compile,
  ['] rot compile,
  ['] swap compile,
  postpone >r
  postpone >r ;  

: type ( o -- ) . ;

: space ( -- )
  32 >charstring . ;

: spaces ( n -- )
  0 do space loop ;

: emit ( n -- )
  >charstring . ;

: cr ( -- )
  10 emit ;

" true" " java.lang.Boolean" 1 jnewn constant jtrue 
" false" " java.lang.Boolean" 1 jnewn constant jfalse 

: jbool>int ( jbool -- f )
    jtrue " compareTo" 1 jinvoken not ;

\ Mathematics

: <= > not ;
: >= < not ;
: abs dup 0 < if -1 * then ;

: d<= d> not ;
: d>= d< not ;
: dabs dup 0. d< if -1. d* then ;

\ Utilities

