/*
 * IntToken.java
 *
 * Created on 17 agosto 2007, 20.18
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.compiler;

import leonardoce.forth.ForthException;
import leonardoce.forth.vm.Memory;
import leonardoce.forth.vm.VmStatus;
import leonardoce.forth.vm.primitives.StaticPushData;

/**
 *
 * @author leonardo
 */
public class DoubleToken implements Token {
    private double _i;
    
    public DoubleToken(String i) {
        _i=Double.parseDouble(i);
    }

    public void compile(VmStatus vm) {
        Memory currentMemory=vm.getCurrentMemory();
        int here=vm.getHere();
        currentMemory.store(here, new StaticPushData(_i));
        vm.setHere(vm.getHere()+1);
    }
        
    public void execute(VmStatus vm) throws ForthException {
        new StaticPushData(_i).execute(vm);
    }
}