/*
 * AbstractForthInputStream.java
 *
 * Created on 17 agosto 2007, 22.51
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm;

import leonardoce.forth.ForthException;

/**
 *
 * @author leonardo
 */
public abstract class AbstractForthInputStream implements ForthInputStream {

    private static boolean charIsIgnorable(char c) {
        if(Character.isSpaceChar(c) || c==10 || c==13) {
            return true;
        } else {
            return false;
        }
    }
    
    public String readWord()  throws ForthException {
        StringBuffer sb=new StringBuffer();
        
        // Strip front spaces
        while(true) {
            char c=readChar();
            
            if(c==0) {
                return "";
            }
            
            if(!charIsIgnorable(c)) {
                sb.append(c);
                break;
            }
        }

        while(true)
        {
            char c=readChar();
            if(c==10 || c==13 || c==' ' || c==0) {
                break;
            }
            sb.append(c);
        }

        return sb.toString();
    }
}
