/*
 * InputStreamAdaptor.java
 *
 * Created on 17 agosto 2007, 22.38
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm;

import java.io.IOError;
import java.io.IOException;
import java.io.InputStream;
import leonardoce.forth.ForthException;

/**
 *
 * @author leonardo
 */
public class InputStreamAdaptor extends AbstractForthInputStream {
    private InputStream _is;

    public InputStreamAdaptor(InputStream is) {
        _is=is;
    }

    public char readChar()  throws ForthException {
        try
        {
            int b=_is.read();
            if(b==-1)
            {
                return 0;
            } else
            {
                return (char)b;
            }
        } catch(IOException ioe)
        {
            throw new ForthException(ioe);
        }
    }
    
}
