/*
 * InterpreterStatus.java
 *
 * Created on 17 agosto 2007, 18.31
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm;

import java.io.InputStream;
import java.util.Stack;
import leonardoce.forth.*;

/**
 *
 * @author leonardo
 */
public interface VmStatus {
    public ForthInputStream getInputStream();
    public void setInputStream(ForthInputStream fis);
    public ForthOutputStream getForthOutputStream();
    public void setForthOutputStream(ForthOutputStream fos);
    public Dictionary getCurrentDictionary();
    public Memory getCurrentMemory();
    public Stack<Object> getDataStack();
    public Stack<Object> getReturnStack();
    public Stack<Object> getControlStack();
    public int getProgramCounter();
    public void setProgramCounter(int pc);
    public int getHere();
    public void setHere(int h);
    public boolean isActive();
    public boolean isCompiling();
    public void setCompiling(boolean stat);
    public String dump();
}
