/*
 * PopRet.java
 *
 * Created on 17 agosto 2007, 21.31
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm.primitives;

import leonardoce.forth.ForthException;
import leonardoce.forth.vm.AbstractPrimitive;
import leonardoce.forth.vm.VmStatus;

/**
 *
 * @author leonardo
 */
public class PopRet extends AbstractPrimitive {
    
    /** Creates a new instance of PopRet */
    public PopRet() {
    }

    public void execute(VmStatus is) throws ForthException {
        if(is.getReturnStack().size()==0)
        {
            throw new ForthException("Underflow on return stack");
        } else
        {
            Object obj=is.getReturnStack().pop();
            is.getDataStack().push(obj);
        }
    }

    public String getName() {
        return "popret";
    }

    public String getDocumentation() {
        return "This is an internal primitive and doesn't corrispond to any forth word";
    }
    
}
