/*
 * PutInteger.java
 *
 * Created on 17 agosto 2007, 19.55
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm.primitives;

import leonardoce.forth.ForthException;
import leonardoce.forth.vm.VmStatus;
import leonardoce.forth.vm.AbstractPrimitive;

/**
 *
 * @author leonardo
 */
public class StaticPushData extends AbstractPrimitive {
    private Object _i;
    
    public StaticPushData(Object i) {
        _i=i;
    }

    public void execute(VmStatus is) throws ForthException {
        is.getDataStack().push(_i);
    } 

    public String getName() {
        return "Push "+_i;
    }

    public String getDocumentation() {
        return "This is an internal primitive and doesn't corrispond to any forth word";
    }
}
