/*
 * PushRet.java
 *
 * Created on 17 agosto 2007, 20.00
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm.primitives;

import leonardoce.forth.ForthException;
import leonardoce.forth.vm.VmStatus;
import leonardoce.forth.vm.AbstractPrimitive;

/**
 *
 * @author leonardo
 */
public class StaticPushRet extends AbstractPrimitive {
    private Object _o;
    
    public StaticPushRet(Object o) {
        _o=o;
    }

    public void execute(VmStatus is) throws ForthException {
        is.getReturnStack().push(_o);
    }

    public String getName() {
        return("PushRet "+_o);
    }

    public String getDocumentation() {
        return "This is an internal primitive and doesn't corrispond to any forth word";
    }
}
