/*
 * Minus.java
 *
 * Created on 17 agosto 2007, 22.46
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm.primitives.cflow;
import leonardoce.forth.ForthException;
import leonardoce.forth.vm.AbstractPrimitive;
import leonardoce.forth.vm.StackMarker;
import leonardoce.forth.vm.VmStatus;
import leonardoce.forth.vm.primitives.sys.Comment;

/**
 * TODO
 * @author leonardo
 */
public class LeavePrim extends AbstractPrimitive {
    
    /** Creates a new instance of Plus */
    public LeavePrim() {
    }

    public void execute(VmStatus is) throws ForthException {
        if(!is.isCompiling()) {
            throw new ForthException("\"leave\" is valid only in compiler mode");
        }
        
        is.getControlStack().add(new StackMarker("leave", is.getHere()));
        is.getCurrentMemory().store(is.getHere(), new Comment("leave here"));
        is.setHere(is.getHere()+1);
    }
    
    public String getName()
    {
        return "leave";
    }  
    
    public boolean isImmediate() {
        return true;
    }

    public String getDocumentation() {
        String retValue;
        
        retValue = super.getDocumentation();
        return "immediate\nCompile the code to leave from a \"begin\"--\"repeat\" loop\n";
    }
    
    
}
