/*
 * Minus.java
 *
 * Created on 17 agosto 2007, 22.46
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm.primitives.doublemath;

import leonardoce.forth.ForthException;
import leonardoce.forth.vm.AbstractPrimitive;
import leonardoce.forth.vm.VmStatus;

/**
 *
 * @author leonardo
 */
public class DEqual extends AbstractPrimitive {
    
    /** Creates a new instance of Plus */
    public DEqual() {
    }

    public void execute(VmStatus is) throws ForthException {
        double a2=(Double)is.getDataStack().pop();
        double a1=(Double)is.getDataStack().pop();
        is.getDataStack().push(a1==a2?-1:0);
    }
    
    public String getName()
    {
        return "d=";
    }  
}
