/*
 * Minus.java
 *
 * Created on 17 agosto 2007, 22.46
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm.primitives.obj;

import leonardoce.forth.ForthException;
import leonardoce.forth.vm.AbstractPrimitive;
import leonardoce.forth.vm.VmStatus;

/**
 *
 * @author leonardo
 */
public class NullQuestion extends AbstractPrimitive {
    
    /** Creates a new instance of Plus */
    public NullQuestion() {
    }

    public void execute(VmStatus is) throws ForthException {
       Object a2=is.getDataStack().pop();
       is.getDataStack().push(a2==null?-1:0);
    }
    
    public String getName()
    {
        return "null?";
    }  

    public String getDocumentation() {
        return "( obj -- flag )\nReturn -1 if the object is \"null\" and 0 otherwise.";
    }
}
