/*
 * Minus.java
 *
 * Created on 17 agosto 2007, 22.46
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm.primitives.obj;

import leonardoce.forth.ForthException;
import leonardoce.forth.vm.AbstractPrimitive;
import leonardoce.forth.vm.VmStatus;

/**
 *
 * @author leonardo
 */
public class ToClassName extends AbstractPrimitive {
    
    /** Creates a new instance of Plus */
    public ToClassName() {
    }

    public void execute(VmStatus is) throws ForthException {
       Object a2=is.getDataStack().pop();
       is.getDataStack().push(a2.getClass().getName());
    }
    
    public String getName()
    {
        return ">classname";
    }  

    public String getDocumentation() {
        return " ( obj -- classname )\nReturn the classname, as string, of the passed object";
    }
}
