/*
 * Colon.java
 *
 * Created on 17 agosto 2007, 21.15
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm.primitives.parsing;

import leonardoce.forth.ForthException;
import leonardoce.forth.vm.AbstractPrimitive;
import leonardoce.forth.vm.VmStatus;
import leonardoce.forth.vm.primitives.ReturnPrimitive;
import leonardoce.forth.vm.primitives.StaticPushData;

/**
 *
 * @author leonardo
 */
public class Parse extends AbstractPrimitive {    
    /** Creates a new instance of Colon */
    public Parse() {
    }

    public void execute(VmStatus is) throws ForthException {
        int charEnd=(Integer)is.getDataStack().pop();
        StringBuffer sb=new StringBuffer();
        
        while(true) {
            int c=is.getInputStream().readChar();
            if(c==charEnd || c==0) break;
            sb.append((char)c);
        }
        
        is.getDataStack().push(sb.toString());
    }

    public String getName() {
        return "parse";
    }
        
    public boolean isImmediate() {
        return false;
    }
}
