/*
 * PopRet.java
 *
 * Created on 17 agosto 2007, 21.31
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm.primitives.returnstack;

import leonardoce.forth.ForthException;
import leonardoce.forth.vm.AbstractPrimitive;
import leonardoce.forth.vm.VmStatus;
import leonardoce.forth.vm.primitives.PushRet;

/**
 *
 * @author leonardo
 */
public class ToRet extends AbstractPrimitive {
    
    /** Creates a new instance of PopRet */
    public ToRet() {
    }

    public void execute(VmStatus is) throws ForthException {
        if(!is.isCompiling()) {
            throw new ForthException("Cannot use r> if you are not compiling.");
        }
        is.getCurrentMemory().store(is.getHere(), new PushRet());
        is.setHere(is.getHere()+1);
    }

    public String getName() {
        return ">r";
    }

    public String getDocumentation() {
        return "( a -- r:a )";
    }
    
    public boolean isImmediate() {
        return true;
    }
}
