/*
 * Colon.java
 *
 * Created on 17 agosto 2007, 21.15
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm.primitives.sys;

import leonardoce.forth.ForthException;
import leonardoce.forth.vm.AbstractPrimitive;
import leonardoce.forth.vm.VmStatus;

/**
 *
 * @author leonardo
 */
public abstract class AbstractColon extends AbstractPrimitive {    
    /** Creates a new instance of Colon */
    public AbstractColon() {
    }

    public void execute(VmStatus is) throws ForthException {
        String wordName=is.getInputStream().readWord();
        is.getCurrentDictionary().getActiveVocabulary().registerWord(wordName, is.getHere(), isCreatedWordImmediate());
        is.setCompiling(true);
        
        is.getCurrentMemory().store(is.getHere(), new Comment("Colondef "+wordName));
        is.setHere(is.getHere()+1);
    }

    public boolean isImmediate() {
        return true;
    }
    
    public abstract boolean isCreatedWordImmediate();    
}
