/*
 * Colon.java
 *
 * Created on 17 agosto 2007, 21.15
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm.primitives.sys;

import leonardoce.forth.ForthException;
import leonardoce.forth.vm.AbstractPrimitive;
import leonardoce.forth.vm.VmStatus;
import leonardoce.forth.vm.primitives.ReturnPrimitive;
import leonardoce.forth.vm.primitives.StaticPushData;

/**
 *
 * @author leonardo
 */
public class CharPrim extends AbstractPrimitive {    
    /** Creates a new instance of Colon */
    public CharPrim() {
    }

    public void execute(VmStatus is) throws ForthException {  
        if(!is.isCompiling()) {
            throw new ForthException("You can't use [char] if you are not compiling.");
        }
        
        String wordName=is.getInputStream().readWord();
        Integer i=new Integer((int)wordName.charAt(0));
        is.getCurrentMemory().store(is.getHere(), new StaticPushData(i));
        is.setHere(is.getHere()+1);
    }

    public String getName() {
        return "[char]";
    }
        
    public boolean isImmediate() {
        return true;
    }
}
