/*
 * Minus.java
 *
 * Created on 17 agosto 2007, 22.46
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm.primitives.sys;

import leonardoce.forth.ForthException;
import leonardoce.forth.vm.AbstractPrimitive;
import leonardoce.forth.vm.VmStatus;
import leonardoce.forth.vm.primitives.StaticPushData;

/**
 *
 * @author leonardo
 */
public class Literal extends AbstractPrimitive {
    public void execute(VmStatus is) throws ForthException {
        if(!is.isCompiling()) {
            throw new ForthException("Cannot use literal if you are not compiling");
        }
        Object a2=is.getDataStack().pop();
        is.getCurrentMemory().store(is.getHere(), new StaticPushData(a2));
        is.setHere(is.getHere()+1);
    }
    
    public String getName()
    {
        return "literal";
    }  
    
    public boolean isImmediate() {
        return true;
    }
}
