/*
 * LeoForth.java
 *
 * Created on 17 agosto 2007, 22.28
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth;

import java.io.IOException;
import leonardoce.forth.compiler.LexicalAnalyzer;
import leonardoce.forth.compiler.Token;
import leonardoce.forth.vm.VmStatus;

/**
 *
 * @author leonardo
 */
public class LeoForth {
    private VmStatus _vms;
    private LexicalAnalyzer _la;
    
    public LeoForth(VmStatus vms) {
        _vms=vms;
        _la=new LexicalAnalyzer();
    }
    
    public void run() throws ForthException {
        _la.setInputStream(_vms.getInputStream());
        while(true)
        {
            Token tk=_la.read();
            if(tk==null)
            {
                break;
            }
            if(_vms.isCompiling())
            {
                tk.compile(_vms);
            } else
            {
                tk.execute(_vms);
            }
        }
    }
}
