/*
 * ForthEditorView.java
 *
 * Created on 20 agosto 2007, 16.52
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.gui;

import java.io.File;

/**
 *
 * @author leonardo
 */
public interface ForthEditorView {
    public void setController(ForthEditorController controller);
    
    public void setText(String s);
    public String getText();
    
    public void showErrorMessage(String msg);
    public void requestFocus();
    
    public void createNewTab();
    public void deleteActiveTab();

    public String getCurrentTabTitle();
    public void setCurrentTabTitle(String s);
    public File getCurrentTabFile();
    public void setCurrentTabFile(File f);
    
    public Iterable<String> getTabTitles();
}
