/*
 * ForthEditorKit.java
 *
 * Created on 21 agosto 2007, 11.25
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.gui.swing;

import java.awt.event.ActionEvent;
import javax.swing.Action;
import javax.swing.UIManager;
import javax.swing.text.JTextComponent;
import javax.swing.text.StyledEditorKit;
import javax.swing.text.TextAction;

/**
 *
 * @author leonardo
 */
public class ForthEditorKit extends StyledEditorKit {
    private String tabString;
    
    public ForthEditorKit() {
        tabString="    ";
    }
    
    public class ForthInsertTabAction extends TextAction {
        public ForthInsertTabAction() {
            super(insertTabAction);
        }

        public void actionPerformed(ActionEvent e) {
            JTextComponent target = getTextComponent(e);
            if (target != null) {
		if ((! target.isEditable()) || (! target.isEnabled())) {
		    UIManager.getLookAndFeel().provideErrorFeedback(target);
		    return;
		}
                target.replaceSelection(tabString);
            }
        }
    }
    
    public Action[] getActions() {
        Action[] forthActions = {
            new ForthInsertTabAction()
        };
	return TextAction.augmentList(super.getActions(), forthActions);
    }
}
