/*
 * LeonardoForth.java
 *
 * Created on 17 agosto 2007, 19.06
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm;

import java.io.IOException;
import java.io.InputStream;
import leonardoce.forth.*;
import leonardoce.forth.vm.primitives.StaticPushData;

/**
 *
 * @author leonardo
 */
public class ForthVm {
    private VmStatus is;
    
    public ForthVm(VmStatus initStatus)
    {
        is=initStatus;
    }
    
    public void executeOneStep() throws ForthException {
        // Executing
        Memory currentMemory=is.getCurrentMemory();
        Object toExecute=currentMemory.get(is.getProgramCounter());
        // DEBUG System.out.println(is.getProgramCounter()+" EXE> "+toExecute);
        is.setProgramCounter(is.getProgramCounter()+1);
        if(toExecute instanceof Primitive)
        {
            Primitive pw=(Primitive)toExecute;
            pw.execute(is);
        } else {
            throw new UnknownExecutable(toExecute);
        }
    }
}
