/*
 * Memory.java
 *
 * Created on 17 agosto 2007, 18.32
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm;

import java.util.Vector;

/**
 *
 * @author leonardo
 */
public class Memory {
    private Vector<Object> internalMem;
    
    public Memory() {
        internalMem=new Vector<Object>();
    }
    
    public void store(int address, Object what)
    {
        if(internalMem.size()<=address){
            internalMem.setSize(address+1);
        }
        internalMem.ensureCapacity(address+1);
        internalMem.set(address, what);
    }
    
    public Object get(int address)
    {
        if(internalMem.size()<=address) {
            return null;
        } else
        {
            return internalMem.get(address);
        }
    }
    
    public String dump() 
    {
        StringBuffer sb=new StringBuffer();
        
        for(int i=0;i<internalMem.size();i++) {
            sb.append(i);
            sb.append(": ");
            if(internalMem.get(i)==null) {
                sb.append("null");
            } else {
                sb.append(internalMem.get(i).toString());
            }
            sb.append("\n");
        }
        
        return sb.toString();
    }
}
