/*
 * StringReaderAdaptor.java
 *
 * Created on 17 agosto 2007, 22.53
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm;

import java.io.IOException;
import java.io.Reader;
import leonardoce.forth.ForthException;

/**
 *
 * @author leonardo
 */
public class ReaderAdaptor extends AbstractForthInputStream {
    private Reader _r;

    public ReaderAdaptor(Reader r) {
        _r=r;
    }

    public char readChar() throws ForthException {
        try
        {
            int b=_r.read();
            if(b==-1)
            {
                return 0;
            } else
            {
                return (char)b;
            }
        } catch(IOException ioe)
        {
            throw new ForthException(ioe);
        }
    }
    
}
