/*
 * Return.java
 *
 * Created on 17 agosto 2007, 21.36
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm.primitives;

import leonardoce.forth.ForthException;
import leonardoce.forth.vm.AbstractPrimitive;
import leonardoce.forth.vm.VmStatus;
import leonardoce.forth.vm.primitives.sys.Jump;

/**
 *
 * @author leonardo
 */
public class ReturnPrimitive extends AbstractPrimitive {
    
    /** Creates a new instance of Return */
    public ReturnPrimitive() {
    }

    public void execute(VmStatus is) throws ForthException {
        Integer a1=(Integer)is.getReturnStack().pop();
        is.getDataStack().push(a1);
        new Jump().execute(is);
    }

    public String getName() {
        return "return";
    }

    public String getDocumentation() {
        return "This is an internal primitive and doesn't corrispond to any forth word";
    }
    
    
}
