/*
 * Juml.java
 *
 * Created on 17 agosto 2007, 20.30
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm.primitives;

import leonardoce.forth.ForthException;
import leonardoce.forth.vm.AbstractPrimitive;
import leonardoce.forth.vm.VmStatus;

/**
 *
 * @author leonardo
 */
public class StaticJump extends AbstractPrimitive {    
    private int _addr;
    
    public StaticJump(int addr) {
        _addr=addr;
    }

    public void execute(VmStatus is) throws ForthException {
        is.setProgramCounter(_addr);
    }   

    public String getName() {
        return "Jump "+_addr;
    }

    public String getDocumentation() {
        return "This is an internal primitive and doesn't corrispond to any forth word";
    }
}
