/*
 * Minus.java
 *
 * Created on 17 agosto 2007, 22.46
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm.primitives.cflow;
import leonardoce.forth.ForthException;
import leonardoce.forth.vm.AbstractPrimitive;
import leonardoce.forth.vm.StackMarker;
import leonardoce.forth.vm.VmStatus;
import leonardoce.forth.vm.primitives.sys.Comment;

/**
 * TODO
 * @author leonardo
 */
public class BeginPrim extends AbstractPrimitive {
    
    /** Creates a new instance of Plus */
    public BeginPrim() {
    }

    public void execute(VmStatus is) throws ForthException {
        if(!is.isCompiling()) {
            throw new ForthException("\"begin\" is valid only in compiler mode");
        }
        
        is.getControlStack().add(new StackMarker("begin", is.getHere()));
    }
    
    public String getName()
    {
        return "begin";
    }  
    
    public boolean isImmediate() {
        return true;
    }

    public String getDocumentation() {
        return "immediate\nThis will start a cycle that will be ended by the \"repeat word\"\nPlease see \"repeat\"";
    }
}
