/*
 * Colon.java
 *
 * Created on 17 agosto 2007, 21.15
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm.primitives.sys;

import leonardoce.forth.ForthException;
import leonardoce.forth.vm.AbstractPrimitive;
import leonardoce.forth.vm.VmStatus;

/**
 *
 * @author leonardo
 */
public class Does extends AbstractPrimitive {    
    /** Creates a new instance of Colon */
    public Does() {
    }

    public void execute(VmStatus is) throws ForthException {
        if(!is.isCompiling()) {
            throw new ForthException("cannot use \"does>\" while interpreting.");
        }
            
        // Compile dodoes
        is.getCurrentMemory().store(is.getHere(), new DoDoes());
        is.setHere(is.getHere()+1);
    }

    public String getName() {
        return "does>";
    }
        
    public boolean isImmediate() {
        return true;
    }
}
