/*
 * Jump.java
 *
 * Created on 17 agosto 2007, 21.27
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm.primitives.sys;

import leonardoce.forth.ForthException;
import leonardoce.forth.vm.AbstractPrimitive;
import leonardoce.forth.vm.VmStatus;

/**
 *
 * @author leonardo
 */
public class Jump extends AbstractPrimitive {
    public Jump() {
    }

    public void execute(VmStatus is) throws ForthException {
        Object obj=is.getDataStack().pop();
        if(obj instanceof Integer) {
            int i=(Integer)obj;
            is.setProgramCounter(i);
        } else
        {
            throw new ForthException("Invalid jump location: "+obj);
        }
    }

    public String getName() {
        return "JMP";
    }    
}
