/*
 * Semicolon.java
 *
 * Created on 17 agosto 2007, 21.24
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm.primitives.sys;

import leonardoce.forth.ForthException;
import leonardoce.forth.vm.Memory;
import leonardoce.forth.vm.AbstractPrimitive;
import leonardoce.forth.vm.VmStatus;
import leonardoce.forth.vm.primitives.*;

/**
 *
 * @author leonardo
 */
public class Semicolon extends AbstractPrimitive {    
    public Semicolon() {
    }

    public void execute(VmStatus is) throws ForthException {
        // Compile return code
        Memory mem=is.getCurrentMemory();
        mem.store(is.getHere(), new ReturnPrimitive());
        is.setHere(is.getHere()+1);
        is.setCompiling(false);
    }

    public String getName() {
        return ";";
    }

    public String getDocumentation() {
        return "The column definition must be ended with \";\"";
    }
        
    public boolean isImmediate() {
        return true;
    }
}
